<?php
	// Author: Brian N. Smith
	// Copyright 2006, NuOnce Networks, Inc. All rights reserved.
	// $Id: mysql.php,v 1.1 2006/08/09 10:19:00 Exp $

	function format_bytes ( $size ) {
		switch ( $size ) {
			case $size > 1000000:
				return number_format(ceil($size / 1000000)) . "mb";
				break;
			case $size > 1000:
				return number_format(ceil($size / 1000)) . "k";
				break;
			default:
				return number_format($size) . "b";
				break;
		}
	}

	include("ServerScriptHelper.php");

	$serverScriptHelper = new ServerScriptHelper();
	$cceClient = $serverScriptHelper->getCceClient();

	if (!$serverScriptHelper->getAllowed('adminUser')) {
		header("location: /error/forbidden.html");
		return;
	}

	$backup_file = "/usr/sausalito/ui/web/nuonce/mysql/mysql-dump.sql";

	$factory = $serverScriptHelper->getHtmlComponentFactory("nuonce-mysql", "/nuonce/mysql/mysqlHandler.php");

	$pid = `/sbin/pidof mysqld`;
	$pid = str_replace("\n", "", $pid);

	if ( $pid ) {
		$cfg["enabled"] = 1;
		$access="rw";
	} else {
		$cfg["enabled"] = 0;
		$access="r";
	}

	$cceClient->setObject("System", $cfg, "mysql");
	$nuMYSQL = $cceClient->getObject("System", array(), "mysql");
	$page = $factory->getPage();
	$block = $factory->getPagedBlock("mysql_header", array("server", "sqlpass", "sqldump"));

	$block->addFormField(
		$factory->getBoolean("enabled", $nuMYSQL["enabled"]),
		$factory->getLabel("mysql_enabled"),
		"server");

	$block->addFormField(
		$factory->getTextField("mysqluser", "root", $access),
		$factory->getLabel("username"),
		"sqlpass");

	$old_pass = $factory->getPassword("oldpass", "", FALSE, $access);
	$old_pass->setOptional('silent');
	$block->addFormField(
		$old_pass,
		$factory->getLabel("current_pass"),
		"sqlpass");

	$new_pass = $factory->getPassword("newpass", "", TRUE, $access);
	$new_pass->setOptional('silent');
	$block->addFormField(
		$new_pass,
		$factory->getLabel("mysqlpass"),
		"sqlpass");

	$user = $factory->getTextField("username", $nuMYSQL["username"], $access);
	$user->setOptional('silent');
	$block->addFormField(
		$user,
		$factory->getLabel("username"),
		"sqldump");

	$pass = $factory->getPassword("password", "", FALSE, $access);
	$pass->setOptional('silent');
	$block->addFormField(
		$pass,
		$factory->getLabel("password"),
		"sqldump");

	if ( file_exists($backup_file) ) {
		$last_ran = date("M j Y - g:i a", filemtime($backup_file));
		$fs = format_bytes(filesize($backup_file));
	}

	$block->addFormField(
		$factory->getTextField("last_backup", $last_ran, "r"),
		$factory->getLabel("last_backup"),
		"sqldump");

	$block->addFormField(
		$factory->getTextField("filesize", $fs, "r"),
		$factory->getLabel("filesize"),
		"sqldump");


	echo $page->toHeaderHtml();
	if ( $HTTP_POST_VARS["_PagedBlock_selectedId_mysql_header"] == "sqldump" ) {
		if ( $access == "rw" ) {
			$block->addButton($factory->getButton("javascript: document.form.submit();", "mysqldump"));
		}
		if ( file_exists($backup_file) ) {
			$block->addButton($factory->getButton("/nuonce/mysql/download.php", "download_backup"));
			$block->addButton($factory->getButton("/nuonce/mysql/delete.php", "delete_backup"));
		}
	} else {
		$block->addButton($factory->getSaveButton($page->getSubmitAction()));
	}
	echo $block->toHtml();
	echo $page->toFooterHtml();

	$serverScriptHelper->destructor();

?>
